package com.fp.persistence.pbpm.gene;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TBPMRULES*/
@Embeddable
public class TbpmRulesKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="RULECODE", nullable=false,updatable=false)

/**
* Codigo de regla de negocio
*/
private String rulecode;

@Column(name="COMPANYCODE", nullable=false,updatable=false)

/**
* Codigo de compania
*/
private Integer companycode;

/**Contructor por defecto*/
public TbpmRulesKey(){}
/**Contructor de TbpmRulesKey
@param pRulecode Codigo de regla de negocio
@param pCompanycode Codigo de compania
*/
public TbpmRulesKey(String pRulecode,Integer pCompanycode){
 rulecode=pRulecode;
 companycode=pCompanycode;
}
/**Obtiene el valor de rulecode
@return valor de rulecode*/
public String getRulecode(){
  return rulecode;
}
/**Fija el valor de rulecode
@param pRulecode nuevo Valor de rulecode*/
public void setRulecode(String pRulecode){
  rulecode=pRulecode;
}

/**Obtiene el valor de companycode
@return valor de companycode*/
public Integer getCompanycode(){
  return companycode;
}
/**Fija el valor de companycode
@param pCompanycode nuevo Valor de companycode*/
public void setCompanycode(Integer pCompanycode){
  companycode=pCompanycode;
}

/**Implementacion de la comparacion de TbpmRulesKey
@param o Objeto de comparacion
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TbpmRulesKey))return false;
  TbpmRulesKey that = (TbpmRulesKey) o;
  if (this.getRulecode() == null || that.getRulecode() == null){
      return false;
  }
  if (! this.getRulecode().equals(that.getRulecode())){
    return false;
  }
  if (this.getCompanycode() == null || that.getCompanycode() == null){
      return false;
  }
  if (! this.getCompanycode().equals(that.getCompanycode())){
    return false;
  }
  return true;
}
/**Implementacion del metodo hashCode bajo el patron de Bloch
@return hashCode de la instancia TbpmRulesKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getRulecode() == null ? 0 : this.getRulecode().hashCode());
    result = result * 37 + (this.getCompanycode() == null ? 0 : this.getCompanycode().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
